config/routes.rb
Rails.application.routes.draw do
  get 'welcome/index'

  resources :users do
    resources :comments
  end
   
  root 'users#index'

  get 'users/:id/connect', to:'users#connect', as: :connect_user

  get 'follow/:following', to:'follow#create', as: :follow_user

  get 'follow/destroy/:id', to:'follow#destroy', as: :follow_destroy

  get 'profile', to:'users#profile', as: :show_profile_user

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :user
end

app/models/follow.rb
class Follow < ApplicationRecord
  belongs_to :follower, :class_name => 'User'
  belongs_to :following, :class_name => 'User'
  validates :follower_id, presence:true
  validates :following_id, presence:true
end

app/models/user.rb
class User < ApplicationRecord
    has_many :comments, dependent: :destroy
    has_many :followers, :class_name => 'Follow', :foreign_key => 'follower'
    has_many :following, :class_name => 'Follow', :foreign_key => 'following'
    validates :name, presence: true,
                    length: { minimum: 5 }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  def create
    @user = User.find(params[:user_id])
    @comment = @user.comments.create(comment_params)
    redirect_to user_path(@user)
  end

  def destroy
    @user = User.find(params[:user_id])
    @comment = @user.comments.find(params[:id])
    @comment.destroy
    redirect_to user_path(@user)
  end

  private
    def comment_params
      params.require(:comment).permit(:body)
    end
end

app/controllers/follow_controller.rb
class FollowController < ApplicationController

  def create

    @follow = Follow.new
    @follow.follower = User.find(session[:id_user])
    @follow.following = User.find(params[:following])

    if @follow.save
      redirect_to show_profile_user_path
    else
      redirect_to users_path
    end
  end
  def destroy
    @follow = Follow.find_by_id(params[:id])
    @follow.destroy
    redirect_to show_profile_user_path
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  def index
    @users = User.all
  end

  def show
    @user = User.find(params[:id])
    @users = User.all
    find_followers
  end

  def profile
    @user = User.find(session[:id_user])
    find_followers
    @cuicuitline = Comment.where(user_id: @id_follow).order("updated_at", :desc)
  end
      
  def new
    @user = User.new
  end

  def edit
    @user = User.find(params[:id])
  end

  def create
    @user = User.new(user_params)
    
    if @user.save
      redirect_to @user
    else
      render 'new'
    end
  end

  def update
    @user = User.find(params[:id])
      
    if @user.update(user_params)
      redirect_to @user
    else
      render 'edit'
    end
  end

  def destroy
    @user = User.find(params[:id])
    @user.destroy
   
    redirect_to users_path
  end

  def connect
    session[:id_user] = params[:id]
    @user = User.find(params[:id])
    redirect_to show_profile_user_path
  end
  
  private
    def user_params
      params.require(:user).permit(:name)
    end
  private
    def find_followers
      @follows = Follow.where(follower_id: session[:id_user])
      @id_follow = Array.new
      @id_follow.push(session[:id_user])
      @follows.each do |cefollow|
        @id_follow.push(cefollow.following.id)
      end
    end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/comments/_comment.html.erb
<tr>
  <td>
    <%= comment.body %>
  </td>

  <% if session[:id_user] == comment.user.id.to_s %>
    <td class="offset-md-2">
      <%= link_to 'Destroy Cuicuit', [comment.user, comment],
                  :class => "btn btn-danger",
                  method: :delete,
                  data: {confirm: 'Are you sure?'} %>
    </td>
  <% else %>
    <td class="offset-md-2"></td>
  <% end %>
</tr>

app/views/comments/_form.html.erb
<%= form_with(model: [ @user, @user.comments.build ], local: true) do |form| %>
  <p>
    <%= form.label :body %><br>
    <%= form.text_area :body %>
  </p>
  <p>
    <%= form.submit "Create a Cuicuit", :class => "btn btn-primary"%>
  </p>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>RailsCuicuitter</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/users/_form.html.erb
<%= form_with model: @user, local: true do |form| %>
 
    <% if @user.errors.any? %>
      <div id="error_explanation" class="bg-danger">
        <h2>
          <%= pluralize(@user.errors.count, "error") %> prohibited
          this user from being saved:
        </h2>
        <ul>
          <% @user.errors.full_messages.each do |msg| %>
            <li><%= msg %></li>
          <% end %>
        </ul>
      </div>
    <% end %>
   
    <p>
      <%= form.label :name %>
      <%= form.text_field :name %>
    </p>

    <p>
      <%= form.submit "Validate", :class => "btn btn-primary" %>
    </p>
   
  <% end %>

app/views/users/edit.html.erb
<html>
  <div class="col-md-10 offset-md-1" style="text-align:center">
    <div class="row bg-light">
      <div class="col-md-3">
        <%= link_to (image_tag"Chirper.png", :style => 'height:50%;'), users_path %>
      </div>
      <h2 class="col-md-4 offset-md-1" style="margin-top:2%">
        Edit User
      </h2>

    </div>
    <%= render 'form' %>
    <%= link_to 'Back', users_path, :class => "btn btn-primary" %>
  </div>
</html>

app/views/users/index.html.erb
<html>
<div class="col-md-10 offset-md-1">
  <div class="row bg-light">
    <div class="col-md-3">
      <%= link_to (image_tag"Chirper.png", :style => 'height:50%;'), users_path %>
    </div>
    <h2 class="col-md-5 offset-md-2" style="margin-top:2%">
      Listing Users
    </h2>

  </div>
  <%= link_to 'New user', new_user_path, :class => "btn btn-success" %>
  <table class="table table-bordered" style="text-align:center;">
    <tr>
      <th>Name</th>
      <th>Connexion</th>
      <th>Modification</th>
      <th>Destruction</th>
    </tr>

    <% @users.each do |user| %>
      <tr>
        <td><%= user.name %></td>
        <td><%= link_to 'Show', connect_user_path(user.id), :class => "btn btn-success" %></td>
        <td><%= link_to 'Edit', edit_user_path(user), :class => "btn btn-primary" %></td>
        <td><%= link_to 'Destroy', user_path(user), :class => "btn btn-danger",
                        method: :delete,
                        data: {confirm: 'Are you sure?'} %></td>
      </tr>
    <% end %>
  </table>
</div>
</html>

app/views/users/new.html.erb
<html>
<div class="col-md-10 offset-md-1" style="text-align:center">
  <div class="row bg-light">
    <div class="col-md-3">
      <%= link_to (image_tag"Chirper.png", :style => 'height:50%;'), users_path %>
    </div>
    <h2 class="col-md-4 offset-md-1" style="margin-top:2%">
      New User
    </h2>

  </div>
  <%= render 'form' %>
  <%= link_to 'Back', users_path, :class => "btn btn-primary" %>
</div>
</html>

app/views/users/profile.html.erb
<html>
<div class="col-md-10 offset-md-1" style="margin-top:2%">

  <div class="row bg-light">
    <div class="col-md-3">
      <%= link_to (image_tag"Chirper.png", :style => 'height:50%;'), users_path %>
    </div>
    <h2 class="col-md-5 offset-md-1" style="margin-top:2%">
      Your profile
    </h2>

  </div>
  <div class="row" style="text-align:center;">
    <p class="col-md-4 md-offset-1">
      <strong>Name: <%= @user.name %></strong>
    </p>
    <p class="col-md-4 md-offset-1"><strong><%= link_to 'Go to User Page', user_path(session[:id_user]), :class => "btn btn-info" %></strong></p>

  </div>
  <div class="row">
    <div class="col-md-6">
      <h2>CuicuitLine</h2>
      <table class="table table-borderless">
        <%= render @cuicuitline %>
      </table>
    </div>
    <div class="col-md-6" style="text-align:center">
      <h2>Add a cuicuit:</h2>
      <%= render 'comments/form' %>
    </div>
  </div>
</div>
</html>

app/views/users/show.html.erb
<html>
  <div class="col-md-10 offset-md-1" style="margin-top:2%">
    <div class="row bg-light">
      <div class="col-md-3">
        <%= link_to (image_tag"Chirper.png", :style => 'height:50%;'), users_path %>
      </div>
      <h2 class="col-md-5 offset-md-1" style="margin-top:2%">
        User's page of
        <%= @user.name %>
      </h2>
      <div class="col-md-3">
        <%= link_to 'Return to my profile',show_profile_user_path, :class => "btn btn-secondary", :style => "margin-top:10%; align:right"  %>
      </div>

    </div>
    <div class="row">
      <div class="col-md-8">
        <h2>Cuicuits</h2>
        <table class="table table-borderless">
          <%= render @user.comments %>
        </table>

        <%= link_to 'Edit the user', edit_user_path(@user), :class => "btn btn-info" %>
      </div>
      <div class="col-md-4">
        <h1>Listing Users</h1>
        <%= link_to 'New user', new_user_path, :class => "btn btn-success"%>
        <table class="table table-borderless">
          <% @users.each do |user| %>
            <%if (session[:id_user] != user.id.to_s) && !(@id_follow.include?(user.id))%>
              <tr>
                <td><%= user.name %></td>
                <td><%= link_to 'Show', user_path(user.id), :class => "btn btn-primary" %></td>
                <td><%= link_to 'Follow', follow_user_path(user.id),:class => "btn btn-success" %></td>
              </tr>
            <% end %>
          <% end %>

        </table>
        <h1>Personnes Suivies</h1>
        <table class="table table-borderless" style="text-align:center">
          <% @follows.each do |cefollow| %>
            <tr>
              <td><%= cefollow.following.name %></td>
              <td><%= link_to 'Profil de ' + cefollow.following.name , user_path(cefollow.following.id), :class => "btn btn-primary" %></td>
              <td><%= link_to 'Unfollow', follow_destroy_path(cefollow.id), :class => "btn btn-danger" %></td>
            </tr>
          <% end %>
        </table>
      </div>
    </div>
  </div>
</html>

app/views/welcome/index.html.erb
<h1>Hello, Rails!</h1>
<%= link_to 'Cuicuitter', controller: 'users' %>